// GENERATED CODE - DO NOT MODIFY BY HAND

part of 'Database.dart';

// **************************************************************************
// MoorGenerator
// **************************************************************************

// ignore_for_file: unnecessary_brace_in_string_interps, unnecessary_this
class Nickname extends DataClass implements Insertable<Nickname> {
  final String macAddress;
  final String nickname;
  Nickname({required this.macAddress, required this.nickname});
  factory Nickname.fromData(Map<String, dynamic> data, GeneratedDatabase db,
      {String? prefix}) {
    final effectivePrefix = prefix ?? '';
    final stringType = db.typeSystem.forDartType<String>();
    return Nickname(
      macAddress: stringType
          .mapFromDatabaseResponse(data['${effectivePrefix}mac_address'])!,
      nickname: stringType
          .mapFromDatabaseResponse(data['${effectivePrefix}nickname'])!,
    );
  }
  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    map['mac_address'] = Variable<String>(macAddress);
    map['nickname'] = Variable<String>(nickname);
    return map;
  }

  NicknamesCompanion toCompanion(bool nullToAbsent) {
    return NicknamesCompanion(
      macAddress: Value(macAddress),
      nickname: Value(nickname),
    );
  }

  factory Nickname.fromJson(Map<String, dynamic> json,
      {ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return Nickname(
      macAddress: serializer.fromJson<String>(json['macAddress']),
      nickname: serializer.fromJson<String>(json['nickname']),
    );
  }
  @override
  Map<String, dynamic> toJson({ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return <String, dynamic>{
      'macAddress': serializer.toJson<String>(macAddress),
      'nickname': serializer.toJson<String>(nickname),
    };
  }

  Nickname copyWith({String? macAddress, String? nickname}) => Nickname(
        macAddress: macAddress ?? this.macAddress,
        nickname: nickname ?? this.nickname,
      );
  @override
  String toString() {
    return (StringBuffer('Nickname(')
          ..write('macAddress: $macAddress, ')
          ..write('nickname: $nickname')
          ..write(')'))
        .toString();
  }

  @override
  int get hashCode => $mrjf($mrjc(macAddress.hashCode, nickname.hashCode));
  @override
  bool operator ==(dynamic other) =>
      identical(this, other) ||
      (other is Nickname &&
          other.macAddress == this.macAddress &&
          other.nickname == this.nickname);
}

class NicknamesCompanion extends UpdateCompanion<Nickname> {
  final Value<String> macAddress;
  final Value<String> nickname;
  const NicknamesCompanion({
    this.macAddress = const Value.absent(),
    this.nickname = const Value.absent(),
  });
  NicknamesCompanion.insert({
    required String macAddress,
    required String nickname,
  })   : macAddress = Value(macAddress),
        nickname = Value(nickname);
  static Insertable<Nickname> custom({
    Expression<String>? macAddress,
    Expression<String>? nickname,
  }) {
    return RawValuesInsertable({
      if (macAddress != null) 'mac_address': macAddress,
      if (nickname != null) 'nickname': nickname,
    });
  }

  NicknamesCompanion copyWith(
      {Value<String>? macAddress, Value<String>? nickname}) {
    return NicknamesCompanion(
      macAddress: macAddress ?? this.macAddress,
      nickname: nickname ?? this.nickname,
    );
  }

  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    if (macAddress.present) {
      map['mac_address'] = Variable<String>(macAddress.value);
    }
    if (nickname.present) {
      map['nickname'] = Variable<String>(nickname.value);
    }
    return map;
  }

  @override
  String toString() {
    return (StringBuffer('NicknamesCompanion(')
          ..write('macAddress: $macAddress, ')
          ..write('nickname: $nickname')
          ..write(')'))
        .toString();
  }
}

class $NicknamesTable extends Nicknames
    with TableInfo<$NicknamesTable, Nickname> {
  final GeneratedDatabase _db;
  final String? _alias;
  $NicknamesTable(this._db, [this._alias]);
  final VerificationMeta _macAddressMeta = const VerificationMeta('macAddress');
  @override
  late final GeneratedTextColumn macAddress = _constructMacAddress();
  GeneratedTextColumn _constructMacAddress() {
    return GeneratedTextColumn('mac_address', $tableName, false,
        minTextLength: 17, maxTextLength: 17);
  }

  final VerificationMeta _nicknameMeta = const VerificationMeta('nickname');
  @override
  late final GeneratedTextColumn nickname = _constructNickname();
  GeneratedTextColumn _constructNickname() {
    return GeneratedTextColumn(
      'nickname',
      $tableName,
      false,
    );
  }

  @override
  List<GeneratedColumn> get $columns => [macAddress, nickname];
  @override
  $NicknamesTable get asDslTable => this;
  @override
  String get $tableName => _alias ?? 'nicknames';
  @override
  final String actualTableName = 'nicknames';
  @override
  VerificationContext validateIntegrity(Insertable<Nickname> instance,
      {bool isInserting = false}) {
    final context = VerificationContext();
    final data = instance.toColumns(true);
    if (data.containsKey('mac_address')) {
      context.handle(
          _macAddressMeta,
          macAddress.isAcceptableOrUnknown(
              data['mac_address']!, _macAddressMeta));
    } else if (isInserting) {
      context.missing(_macAddressMeta);
    }
    if (data.containsKey('nickname')) {
      context.handle(_nicknameMeta,
          nickname.isAcceptableOrUnknown(data['nickname']!, _nicknameMeta));
    } else if (isInserting) {
      context.missing(_nicknameMeta);
    }
    return context;
  }

  @override
  Set<GeneratedColumn> get $primaryKey => {macAddress};
  @override
  Nickname map(Map<String, dynamic> data, {String? tablePrefix}) {
    final effectivePrefix = tablePrefix != null ? '$tablePrefix.' : null;
    return Nickname.fromData(data, _db, prefix: effectivePrefix);
  }

  @override
  $NicknamesTable createAlias(String alias) {
    return $NicknamesTable(_db, alias);
  }
}

class LastSeenDevice extends DataClass implements Insertable<LastSeenDevice> {
  final String macAddress;
  final DateTime lastSeen;
  LastSeenDevice({required this.macAddress, required this.lastSeen});
  factory LastSeenDevice.fromData(
      Map<String, dynamic> data, GeneratedDatabase db,
      {String? prefix}) {
    final effectivePrefix = prefix ?? '';
    final stringType = db.typeSystem.forDartType<String>();
    final dateTimeType = db.typeSystem.forDartType<DateTime>();
    return LastSeenDevice(
      macAddress: stringType
          .mapFromDatabaseResponse(data['${effectivePrefix}mac_address'])!,
      lastSeen: dateTimeType
          .mapFromDatabaseResponse(data['${effectivePrefix}last_seen'])!,
    );
  }
  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    map['mac_address'] = Variable<String>(macAddress);
    map['last_seen'] = Variable<DateTime>(lastSeen);
    return map;
  }

  LastSeenDevicesCompanion toCompanion(bool nullToAbsent) {
    return LastSeenDevicesCompanion(
      macAddress: Value(macAddress),
      lastSeen: Value(lastSeen),
    );
  }

  factory LastSeenDevice.fromJson(Map<String, dynamic> json,
      {ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return LastSeenDevice(
      macAddress: serializer.fromJson<String>(json['macAddress']),
      lastSeen: serializer.fromJson<DateTime>(json['lastSeen']),
    );
  }
  @override
  Map<String, dynamic> toJson({ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return <String, dynamic>{
      'macAddress': serializer.toJson<String>(macAddress),
      'lastSeen': serializer.toJson<DateTime>(lastSeen),
    };
  }

  LastSeenDevice copyWith({String? macAddress, DateTime? lastSeen}) =>
      LastSeenDevice(
        macAddress: macAddress ?? this.macAddress,
        lastSeen: lastSeen ?? this.lastSeen,
      );
  @override
  String toString() {
    return (StringBuffer('LastSeenDevice(')
          ..write('macAddress: $macAddress, ')
          ..write('lastSeen: $lastSeen')
          ..write(')'))
        .toString();
  }

  @override
  int get hashCode => $mrjf($mrjc(macAddress.hashCode, lastSeen.hashCode));
  @override
  bool operator ==(dynamic other) =>
      identical(this, other) ||
      (other is LastSeenDevice &&
          other.macAddress == this.macAddress &&
          other.lastSeen == this.lastSeen);
}

class LastSeenDevicesCompanion extends UpdateCompanion<LastSeenDevice> {
  final Value<String> macAddress;
  final Value<DateTime> lastSeen;
  const LastSeenDevicesCompanion({
    this.macAddress = const Value.absent(),
    this.lastSeen = const Value.absent(),
  });
  LastSeenDevicesCompanion.insert({
    required String macAddress,
    this.lastSeen = const Value.absent(),
  }) : macAddress = Value(macAddress);
  static Insertable<LastSeenDevice> custom({
    Expression<String>? macAddress,
    Expression<DateTime>? lastSeen,
  }) {
    return RawValuesInsertable({
      if (macAddress != null) 'mac_address': macAddress,
      if (lastSeen != null) 'last_seen': lastSeen,
    });
  }

  LastSeenDevicesCompanion copyWith(
      {Value<String>? macAddress, Value<DateTime>? lastSeen}) {
    return LastSeenDevicesCompanion(
      macAddress: macAddress ?? this.macAddress,
      lastSeen: lastSeen ?? this.lastSeen,
    );
  }

  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    if (macAddress.present) {
      map['mac_address'] = Variable<String>(macAddress.value);
    }
    if (lastSeen.present) {
      map['last_seen'] = Variable<DateTime>(lastSeen.value);
    }
    return map;
  }

  @override
  String toString() {
    return (StringBuffer('LastSeenDevicesCompanion(')
          ..write('macAddress: $macAddress, ')
          ..write('lastSeen: $lastSeen')
          ..write(')'))
        .toString();
  }
}

class $LastSeenDevicesTable extends LastSeenDevices
    with TableInfo<$LastSeenDevicesTable, LastSeenDevice> {
  final GeneratedDatabase _db;
  final String? _alias;
  $LastSeenDevicesTable(this._db, [this._alias]);
  final VerificationMeta _macAddressMeta = const VerificationMeta('macAddress');
  @override
  late final GeneratedTextColumn macAddress = _constructMacAddress();
  GeneratedTextColumn _constructMacAddress() {
    return GeneratedTextColumn('mac_address', $tableName, false,
        minTextLength: 17, maxTextLength: 17);
  }

  final VerificationMeta _lastSeenMeta = const VerificationMeta('lastSeen');
  @override
  late final GeneratedDateTimeColumn lastSeen = _constructLastSeen();
  GeneratedDateTimeColumn _constructLastSeen() {
    return GeneratedDateTimeColumn(
      'last_seen',
      $tableName,
      false,
    )..clientDefault = () => DateTime.now();
  }

  @override
  List<GeneratedColumn> get $columns => [macAddress, lastSeen];
  @override
  $LastSeenDevicesTable get asDslTable => this;
  @override
  String get $tableName => _alias ?? 'last_seen_devices';
  @override
  final String actualTableName = 'last_seen_devices';
  @override
  VerificationContext validateIntegrity(Insertable<LastSeenDevice> instance,
      {bool isInserting = false}) {
    final context = VerificationContext();
    final data = instance.toColumns(true);
    if (data.containsKey('mac_address')) {
      context.handle(
          _macAddressMeta,
          macAddress.isAcceptableOrUnknown(
              data['mac_address']!, _macAddressMeta));
    } else if (isInserting) {
      context.missing(_macAddressMeta);
    }
    if (data.containsKey('last_seen')) {
      context.handle(_lastSeenMeta,
          lastSeen.isAcceptableOrUnknown(data['last_seen']!, _lastSeenMeta));
    }
    return context;
  }

  @override
  Set<GeneratedColumn> get $primaryKey => {macAddress};
  @override
  LastSeenDevice map(Map<String, dynamic> data, {String? tablePrefix}) {
    final effectivePrefix = tablePrefix != null ? '$tablePrefix.' : null;
    return LastSeenDevice.fromData(data, _db, prefix: effectivePrefix);
  }

  @override
  $LastSeenDevicesTable createAlias(String alias) {
    return $LastSeenDevicesTable(_db, alias);
  }
}

class SimpleSetting extends DataClass implements Insertable<SimpleSetting> {
  final int settingsId;
  final String? data;
  SimpleSetting({required this.settingsId, this.data});
  factory SimpleSetting.fromData(
      Map<String, dynamic> data, GeneratedDatabase db,
      {String? prefix}) {
    final effectivePrefix = prefix ?? '';
    final intType = db.typeSystem.forDartType<int>();
    final stringType = db.typeSystem.forDartType<String>();
    return SimpleSetting(
      settingsId: intType
          .mapFromDatabaseResponse(data['${effectivePrefix}settings_id'])!,
      data: stringType.mapFromDatabaseResponse(data['${effectivePrefix}data']),
    );
  }
  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    map['settings_id'] = Variable<int>(settingsId);
    if (!nullToAbsent || data != null) {
      map['data'] = Variable<String?>(data);
    }
    return map;
  }

  SimpleSettingsCompanion toCompanion(bool nullToAbsent) {
    return SimpleSettingsCompanion(
      settingsId: Value(settingsId),
      data: data == null && nullToAbsent ? const Value.absent() : Value(data),
    );
  }

  factory SimpleSetting.fromJson(Map<String, dynamic> json,
      {ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return SimpleSetting(
      settingsId: serializer.fromJson<int>(json['settingsId']),
      data: serializer.fromJson<String?>(json['data']),
    );
  }
  @override
  Map<String, dynamic> toJson({ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return <String, dynamic>{
      'settingsId': serializer.toJson<int>(settingsId),
      'data': serializer.toJson<String?>(data),
    };
  }

  SimpleSetting copyWith({int? settingsId, String? data}) => SimpleSetting(
        settingsId: settingsId ?? this.settingsId,
        data: data ?? this.data,
      );
  @override
  String toString() {
    return (StringBuffer('SimpleSetting(')
          ..write('settingsId: $settingsId, ')
          ..write('data: $data')
          ..write(')'))
        .toString();
  }

  @override
  int get hashCode => $mrjf($mrjc(settingsId.hashCode, data.hashCode));
  @override
  bool operator ==(dynamic other) =>
      identical(this, other) ||
      (other is SimpleSetting &&
          other.settingsId == this.settingsId &&
          other.data == this.data);
}

class SimpleSettingsCompanion extends UpdateCompanion<SimpleSetting> {
  final Value<int> settingsId;
  final Value<String?> data;
  const SimpleSettingsCompanion({
    this.settingsId = const Value.absent(),
    this.data = const Value.absent(),
  });
  SimpleSettingsCompanion.insert({
    this.settingsId = const Value.absent(),
    this.data = const Value.absent(),
  });
  static Insertable<SimpleSetting> custom({
    Expression<int>? settingsId,
    Expression<String?>? data,
  }) {
    return RawValuesInsertable({
      if (settingsId != null) 'settings_id': settingsId,
      if (data != null) 'data': data,
    });
  }

  SimpleSettingsCompanion copyWith(
      {Value<int>? settingsId, Value<String?>? data}) {
    return SimpleSettingsCompanion(
      settingsId: settingsId ?? this.settingsId,
      data: data ?? this.data,
    );
  }

  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    if (settingsId.present) {
      map['settings_id'] = Variable<int>(settingsId.value);
    }
    if (data.present) {
      map['data'] = Variable<String?>(data.value);
    }
    return map;
  }

  @override
  String toString() {
    return (StringBuffer('SimpleSettingsCompanion(')
          ..write('settingsId: $settingsId, ')
          ..write('data: $data')
          ..write(')'))
        .toString();
  }
}

class $SimpleSettingsTable extends SimpleSettings
    with TableInfo<$SimpleSettingsTable, SimpleSetting> {
  final GeneratedDatabase _db;
  final String? _alias;
  $SimpleSettingsTable(this._db, [this._alias]);
  final VerificationMeta _settingsIdMeta = const VerificationMeta('settingsId');
  @override
  late final GeneratedIntColumn settingsId = _constructSettingsId();
  GeneratedIntColumn _constructSettingsId() {
    return GeneratedIntColumn(
      'settings_id',
      $tableName,
      false,
    );
  }

  final VerificationMeta _dataMeta = const VerificationMeta('data');
  @override
  late final GeneratedTextColumn data = _constructData();
  GeneratedTextColumn _constructData() {
    return GeneratedTextColumn(
      'data',
      $tableName,
      true,
    );
  }

  @override
  List<GeneratedColumn> get $columns => [settingsId, data];
  @override
  $SimpleSettingsTable get asDslTable => this;
  @override
  String get $tableName => _alias ?? 'simple_settings';
  @override
  final String actualTableName = 'simple_settings';
  @override
  VerificationContext validateIntegrity(Insertable<SimpleSetting> instance,
      {bool isInserting = false}) {
    final context = VerificationContext();
    final data = instance.toColumns(true);
    if (data.containsKey('settings_id')) {
      context.handle(
          _settingsIdMeta,
          settingsId.isAcceptableOrUnknown(
              data['settings_id']!, _settingsIdMeta));
    }
    if (data.containsKey('data')) {
      context.handle(
          _dataMeta, this.data.isAcceptableOrUnknown(data['data']!, _dataMeta));
    }
    return context;
  }

  @override
  Set<GeneratedColumn> get $primaryKey => {settingsId};
  @override
  SimpleSetting map(Map<String, dynamic> data, {String? tablePrefix}) {
    final effectivePrefix = tablePrefix != null ? '$tablePrefix.' : null;
    return SimpleSetting.fromData(data, _db, prefix: effectivePrefix);
  }

  @override
  $SimpleSettingsTable createAlias(String alias) {
    return $SimpleSettingsTable(_db, alias);
  }
}

class ViveBaseStationId extends DataClass
    implements Insertable<ViveBaseStationId> {
  final int id;
  ViveBaseStationId({required this.id});
  factory ViveBaseStationId.fromData(
      Map<String, dynamic> data, GeneratedDatabase db,
      {String? prefix}) {
    final effectivePrefix = prefix ?? '';
    final intType = db.typeSystem.forDartType<int>();
    return ViveBaseStationId(
      id: intType.mapFromDatabaseResponse(data['${effectivePrefix}id'])!,
    );
  }
  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    map['id'] = Variable<int>(id);
    return map;
  }

  ViveBaseStationIdsCompanion toCompanion(bool nullToAbsent) {
    return ViveBaseStationIdsCompanion(
      id: Value(id),
    );
  }

  factory ViveBaseStationId.fromJson(Map<String, dynamic> json,
      {ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return ViveBaseStationId(
      id: serializer.fromJson<int>(json['id']),
    );
  }
  @override
  Map<String, dynamic> toJson({ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return <String, dynamic>{
      'id': serializer.toJson<int>(id),
    };
  }

  ViveBaseStationId copyWith({int? id}) => ViveBaseStationId(
        id: id ?? this.id,
      );
  @override
  String toString() {
    return (StringBuffer('ViveBaseStationId(')..write('id: $id')..write(')'))
        .toString();
  }

  @override
  int get hashCode => $mrjf(id.hashCode);
  @override
  bool operator ==(dynamic other) =>
      identical(this, other) ||
      (other is ViveBaseStationId && other.id == this.id);
}

class ViveBaseStationIdsCompanion extends UpdateCompanion<ViveBaseStationId> {
  final Value<int> id;
  const ViveBaseStationIdsCompanion({
    this.id = const Value.absent(),
  });
  ViveBaseStationIdsCompanion.insert({
    this.id = const Value.absent(),
  });
  static Insertable<ViveBaseStationId> custom({
    Expression<int>? id,
  }) {
    return RawValuesInsertable({
      if (id != null) 'id': id,
    });
  }

  ViveBaseStationIdsCompanion copyWith({Value<int>? id}) {
    return ViveBaseStationIdsCompanion(
      id: id ?? this.id,
    );
  }

  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    if (id.present) {
      map['id'] = Variable<int>(id.value);
    }
    return map;
  }

  @override
  String toString() {
    return (StringBuffer('ViveBaseStationIdsCompanion(')
          ..write('id: $id')
          ..write(')'))
        .toString();
  }
}

class $ViveBaseStationIdsTable extends ViveBaseStationIds
    with TableInfo<$ViveBaseStationIdsTable, ViveBaseStationId> {
  final GeneratedDatabase _db;
  final String? _alias;
  $ViveBaseStationIdsTable(this._db, [this._alias]);
  final VerificationMeta _idMeta = const VerificationMeta('id');
  @override
  late final GeneratedIntColumn id = _constructId();
  GeneratedIntColumn _constructId() {
    return GeneratedIntColumn(
      'id',
      $tableName,
      false,
    );
  }

  @override
  List<GeneratedColumn> get $columns => [id];
  @override
  $ViveBaseStationIdsTable get asDslTable => this;
  @override
  String get $tableName => _alias ?? 'vive_base_station_ids';
  @override
  final String actualTableName = 'vive_base_station_ids';
  @override
  VerificationContext validateIntegrity(Insertable<ViveBaseStationId> instance,
      {bool isInserting = false}) {
    final context = VerificationContext();
    final data = instance.toColumns(true);
    if (data.containsKey('id')) {
      context.handle(_idMeta, id.isAcceptableOrUnknown(data['id']!, _idMeta));
    }
    return context;
  }

  @override
  Set<GeneratedColumn> get $primaryKey => {id};
  @override
  ViveBaseStationId map(Map<String, dynamic> data, {String? tablePrefix}) {
    final effectivePrefix = tablePrefix != null ? '$tablePrefix.' : null;
    return ViveBaseStationId.fromData(data, _db, prefix: effectivePrefix);
  }

  @override
  $ViveBaseStationIdsTable createAlias(String alias) {
    return $ViveBaseStationIdsTable(_db, alias);
  }
}

class Group extends DataClass implements Insertable<Group> {
  final int id;
  final String name;
  Group({required this.id, required this.name});
  factory Group.fromData(Map<String, dynamic> data, GeneratedDatabase db,
      {String? prefix}) {
    final effectivePrefix = prefix ?? '';
    final intType = db.typeSystem.forDartType<int>();
    final stringType = db.typeSystem.forDartType<String>();
    return Group(
      id: intType.mapFromDatabaseResponse(data['${effectivePrefix}id'])!,
      name: stringType.mapFromDatabaseResponse(data['${effectivePrefix}name'])!,
    );
  }
  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    map['id'] = Variable<int>(id);
    map['name'] = Variable<String>(name);
    return map;
  }

  GroupsCompanion toCompanion(bool nullToAbsent) {
    return GroupsCompanion(
      id: Value(id),
      name: Value(name),
    );
  }

  factory Group.fromJson(Map<String, dynamic> json,
      {ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return Group(
      id: serializer.fromJson<int>(json['id']),
      name: serializer.fromJson<String>(json['name']),
    );
  }
  @override
  Map<String, dynamic> toJson({ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return <String, dynamic>{
      'id': serializer.toJson<int>(id),
      'name': serializer.toJson<String>(name),
    };
  }

  Group copyWith({int? id, String? name}) => Group(
        id: id ?? this.id,
        name: name ?? this.name,
      );
  @override
  String toString() {
    return (StringBuffer('Group(')
          ..write('id: $id, ')
          ..write('name: $name')
          ..write(')'))
        .toString();
  }

  @override
  int get hashCode => $mrjf($mrjc(id.hashCode, name.hashCode));
  @override
  bool operator ==(dynamic other) =>
      identical(this, other) ||
      (other is Group && other.id == this.id && other.name == this.name);
}

class GroupsCompanion extends UpdateCompanion<Group> {
  final Value<int> id;
  final Value<String> name;
  const GroupsCompanion({
    this.id = const Value.absent(),
    this.name = const Value.absent(),
  });
  GroupsCompanion.insert({
    this.id = const Value.absent(),
    required String name,
  }) : name = Value(name);
  static Insertable<Group> custom({
    Expression<int>? id,
    Expression<String>? name,
  }) {
    return RawValuesInsertable({
      if (id != null) 'id': id,
      if (name != null) 'name': name,
    });
  }

  GroupsCompanion copyWith({Value<int>? id, Value<String>? name}) {
    return GroupsCompanion(
      id: id ?? this.id,
      name: name ?? this.name,
    );
  }

  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    if (id.present) {
      map['id'] = Variable<int>(id.value);
    }
    if (name.present) {
      map['name'] = Variable<String>(name.value);
    }
    return map;
  }

  @override
  String toString() {
    return (StringBuffer('GroupsCompanion(')
          ..write('id: $id, ')
          ..write('name: $name')
          ..write(')'))
        .toString();
  }
}

class $GroupsTable extends Groups with TableInfo<$GroupsTable, Group> {
  final GeneratedDatabase _db;
  final String? _alias;
  $GroupsTable(this._db, [this._alias]);
  final VerificationMeta _idMeta = const VerificationMeta('id');
  @override
  late final GeneratedIntColumn id = _constructId();
  GeneratedIntColumn _constructId() {
    return GeneratedIntColumn('id', $tableName, false,
        hasAutoIncrement: true, declaredAsPrimaryKey: true);
  }

  final VerificationMeta _nameMeta = const VerificationMeta('name');
  @override
  late final GeneratedTextColumn name = _constructName();
  GeneratedTextColumn _constructName() {
    return GeneratedTextColumn(
      'name',
      $tableName,
      false,
    );
  }

  @override
  List<GeneratedColumn> get $columns => [id, name];
  @override
  $GroupsTable get asDslTable => this;
  @override
  String get $tableName => _alias ?? '"groups"';
  @override
  final String actualTableName = '"groups"';
  @override
  VerificationContext validateIntegrity(Insertable<Group> instance,
      {bool isInserting = false}) {
    final context = VerificationContext();
    final data = instance.toColumns(true);
    if (data.containsKey('id')) {
      context.handle(_idMeta, id.isAcceptableOrUnknown(data['id']!, _idMeta));
    }
    if (data.containsKey('name')) {
      context.handle(
          _nameMeta, name.isAcceptableOrUnknown(data['name']!, _nameMeta));
    } else if (isInserting) {
      context.missing(_nameMeta);
    }
    return context;
  }

  @override
  Set<GeneratedColumn> get $primaryKey => {id};
  @override
  Group map(Map<String, dynamic> data, {String? tablePrefix}) {
    final effectivePrefix = tablePrefix != null ? '$tablePrefix.' : null;
    return Group.fromData(data, _db, prefix: effectivePrefix);
  }

  @override
  $GroupsTable createAlias(String alias) {
    return $GroupsTable(_db, alias);
  }
}

class GroupEntry extends DataClass implements Insertable<GroupEntry> {
  final String macAddress;
  final int groupId;
  GroupEntry({required this.macAddress, required this.groupId});
  factory GroupEntry.fromData(Map<String, dynamic> data, GeneratedDatabase db,
      {String? prefix}) {
    final effectivePrefix = prefix ?? '';
    final stringType = db.typeSystem.forDartType<String>();
    final intType = db.typeSystem.forDartType<int>();
    return GroupEntry(
      macAddress: stringType
          .mapFromDatabaseResponse(data['${effectivePrefix}mac_address'])!,
      groupId:
          intType.mapFromDatabaseResponse(data['${effectivePrefix}group_id'])!,
    );
  }
  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    map['mac_address'] = Variable<String>(macAddress);
    map['group_id'] = Variable<int>(groupId);
    return map;
  }

  GroupEntriesCompanion toCompanion(bool nullToAbsent) {
    return GroupEntriesCompanion(
      macAddress: Value(macAddress),
      groupId: Value(groupId),
    );
  }

  factory GroupEntry.fromJson(Map<String, dynamic> json,
      {ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return GroupEntry(
      macAddress: serializer.fromJson<String>(json['macAddress']),
      groupId: serializer.fromJson<int>(json['groupId']),
    );
  }
  @override
  Map<String, dynamic> toJson({ValueSerializer? serializer}) {
    serializer ??= moorRuntimeOptions.defaultSerializer;
    return <String, dynamic>{
      'macAddress': serializer.toJson<String>(macAddress),
      'groupId': serializer.toJson<int>(groupId),
    };
  }

  GroupEntry copyWith({String? macAddress, int? groupId}) => GroupEntry(
        macAddress: macAddress ?? this.macAddress,
        groupId: groupId ?? this.groupId,
      );
  @override
  String toString() {
    return (StringBuffer('GroupEntry(')
          ..write('macAddress: $macAddress, ')
          ..write('groupId: $groupId')
          ..write(')'))
        .toString();
  }

  @override
  int get hashCode => $mrjf($mrjc(macAddress.hashCode, groupId.hashCode));
  @override
  bool operator ==(dynamic other) =>
      identical(this, other) ||
      (other is GroupEntry &&
          other.macAddress == this.macAddress &&
          other.groupId == this.groupId);
}

class GroupEntriesCompanion extends UpdateCompanion<GroupEntry> {
  final Value<String> macAddress;
  final Value<int> groupId;
  const GroupEntriesCompanion({
    this.macAddress = const Value.absent(),
    this.groupId = const Value.absent(),
  });
  GroupEntriesCompanion.insert({
    required String macAddress,
    required int groupId,
  })   : macAddress = Value(macAddress),
        groupId = Value(groupId);
  static Insertable<GroupEntry> custom({
    Expression<String>? macAddress,
    Expression<int>? groupId,
  }) {
    return RawValuesInsertable({
      if (macAddress != null) 'mac_address': macAddress,
      if (groupId != null) 'group_id': groupId,
    });
  }

  GroupEntriesCompanion copyWith(
      {Value<String>? macAddress, Value<int>? groupId}) {
    return GroupEntriesCompanion(
      macAddress: macAddress ?? this.macAddress,
      groupId: groupId ?? this.groupId,
    );
  }

  @override
  Map<String, Expression> toColumns(bool nullToAbsent) {
    final map = <String, Expression>{};
    if (macAddress.present) {
      map['mac_address'] = Variable<String>(macAddress.value);
    }
    if (groupId.present) {
      map['group_id'] = Variable<int>(groupId.value);
    }
    return map;
  }

  @override
  String toString() {
    return (StringBuffer('GroupEntriesCompanion(')
          ..write('macAddress: $macAddress, ')
          ..write('groupId: $groupId')
          ..write(')'))
        .toString();
  }
}

class $GroupEntriesTable extends GroupEntries
    with TableInfo<$GroupEntriesTable, GroupEntry> {
  final GeneratedDatabase _db;
  final String? _alias;
  $GroupEntriesTable(this._db, [this._alias]);
  final VerificationMeta _macAddressMeta = const VerificationMeta('macAddress');
  @override
  late final GeneratedTextColumn macAddress = _constructMacAddress();
  GeneratedTextColumn _constructMacAddress() {
    return GeneratedTextColumn('mac_address', $tableName, false,
        minTextLength: 17, maxTextLength: 17);
  }

  final VerificationMeta _groupIdMeta = const VerificationMeta('groupId');
  @override
  late final GeneratedIntColumn groupId = _constructGroupId();
  GeneratedIntColumn _constructGroupId() {
    return GeneratedIntColumn('group_id', $tableName, false,
        $customConstraints:
            'NOT NULL REFERENCES "groups"(id) ON DELETE CASCADE ON UPDATE CASCADE');
  }

  @override
  List<GeneratedColumn> get $columns => [macAddress, groupId];
  @override
  $GroupEntriesTable get asDslTable => this;
  @override
  String get $tableName => _alias ?? 'group_entries';
  @override
  final String actualTableName = 'group_entries';
  @override
  VerificationContext validateIntegrity(Insertable<GroupEntry> instance,
      {bool isInserting = false}) {
    final context = VerificationContext();
    final data = instance.toColumns(true);
    if (data.containsKey('mac_address')) {
      context.handle(
          _macAddressMeta,
          macAddress.isAcceptableOrUnknown(
              data['mac_address']!, _macAddressMeta));
    } else if (isInserting) {
      context.missing(_macAddressMeta);
    }
    if (data.containsKey('group_id')) {
      context.handle(_groupIdMeta,
          groupId.isAcceptableOrUnknown(data['group_id']!, _groupIdMeta));
    } else if (isInserting) {
      context.missing(_groupIdMeta);
    }
    return context;
  }

  @override
  Set<GeneratedColumn> get $primaryKey => {macAddress};
  @override
  GroupEntry map(Map<String, dynamic> data, {String? tablePrefix}) {
    final effectivePrefix = tablePrefix != null ? '$tablePrefix.' : null;
    return GroupEntry.fromData(data, _db, prefix: effectivePrefix);
  }

  @override
  $GroupEntriesTable createAlias(String alias) {
    return $GroupEntriesTable(_db, alias);
  }
}

abstract class _$LighthouseDatabase extends GeneratedDatabase {
  _$LighthouseDatabase(QueryExecutor e)
      : super(SqlTypeSystem.defaultInstance, e);
  late final $NicknamesTable nicknames = $NicknamesTable(this);
  late final $LastSeenDevicesTable lastSeenDevices =
      $LastSeenDevicesTable(this);
  late final $SimpleSettingsTable simpleSettings = $SimpleSettingsTable(this);
  late final $ViveBaseStationIdsTable viveBaseStationIds =
      $ViveBaseStationIdsTable(this);
  late final $GroupsTable groups = $GroupsTable(this);
  late final $GroupEntriesTable groupEntries = $GroupEntriesTable(this);
  late final SettingsDao settingsDao = SettingsDao(this as LighthouseDatabase);
  late final NicknameDao nicknameDao = NicknameDao(this as LighthouseDatabase);
  late final ViveBaseStationDao viveBaseStationDao =
      ViveBaseStationDao(this as LighthouseDatabase);
  late final GroupDao groupDao = GroupDao(this as LighthouseDatabase);
  @override
  Iterable<TableInfo> get allTables => allSchemaEntities.whereType<TableInfo>();
  @override
  List<DatabaseSchemaEntity> get allSchemaEntities => [
        nicknames,
        lastSeenDevices,
        simpleSettings,
        viveBaseStationIds,
        groups,
        groupEntries
      ];
}
